#!/usr/bin/perl 
#
# Check da instalaco do IBQUOTA 2.X
# 21/01/05 - Valcir C.
#
# Inserir cabecalho padrao, com a GPL

$versao="0.3  - 23/06/2005";

print "Checador de configuracao do IBQUOTA 2.X\n";
$saida=`pwd`;
print "Versao = $versao                $saida\n";
$saida=`uname -a`;
print "$saida\n";
#Adiciona as funcoes utilizadas
require "funcoes.pl";

#Modulos de Politicas de Impressao
require "modules/grupop.pl";

#Ler as configuracoes
%configuracoes = LER_CONFIGURACOES("./ibquota.conf");

print "DEBUG=$configuracoes{'DEBUG'}\n";
if ($configuracoes{'DEBUG'} < 0) {
  print "Erro: DEBUG INVALIDO\n";
  exit 1;
}
$configuracoes{'DEBUG'}=0;

print "TEMPO_DE_ESPERA=$configuracoes{'TEMPO_DE_ESPERA'}\n";
if ($configuracoes{'TEMPO_DE_ESPERA'} < 1) {
  print "Erro: TEMPO_DE_ESPERA MENOR QUE 1\n";
  exit 1;
}

print "PATH_LPR=$configuracoes{'PATH_LPR'}\n";
if (!-e $configuracoes{'PATH_LPR'}) {
  print "Erro: PATH_LPR INVALIDO\n";
  exit 1;
}
                                                                                                               
print "PATH_LPSTAT=$configuracoes{'PATH_LPSTAT'}\n";
if (!-e $configuracoes{'PATH_LPSTAT'}) {
  print "Erro: PATH_LPSTAT INVALIDO\n";
  exit 1;
}
                                                                                                               
print "PATH_MYSQL=$configuracoes{'PATH_MYSQL'}\n";
if (!-e $configuracoes{'PATH_MYSQL'}) {
  print "Erro: PATH_MYSQL INVALIDO\n";
  exit 1;
}
$saida=`$configuracoes{'PATH_MYSQL'} --version`;
print "Versao MYSQL: $saida\n";

print "NOME_BANCO=$configuracoes{'NOME_BANCO'}\n";
if ($configuracoes{'NOME_BANCO'} eq "") {
  print "Erro: NOME_BANCO INVALIDO\n";
  exit 1;
}

print "PORTA_BANCO=$configuracoes{'PORTA_BANCO'}\n";
if ($configuracoes{'PORTA_BANCO'} eq "") {
  print "Erro: PORTA_BANCO INVALIDA\n";
  exit 1;
}

print "HOST_BANCO=$configuracoes{'HOST_BANCO'}\n";
if ($configuracoes{'HOST_BANCO'} eq "") {
  print "Erro: HOST_BANCO INVALIDO\n";
  exit 1;
}

print "USUARIO_BANCO=$configuracoes{'USUARIO_BANCO'}\n";
if ($configuracoes{'USUARIO_BANCO'} eq "") {
  print "Erro: USUARIO_BANCO INVALIDO\n";
  exit 1;
}

print "TESTANDO ACESSO AO BANCO DE DADOS:";
$configuracoes{'DEBUG'}=2;
my @formato=&EXECUTA_BANCO("select formato.nome_formato from formato;");
$configuracoes{'DEBUG'}=0;
if (scalar @formato < 1) {
  print "Erro: SEM ACESSO AO BANCO (NAO FOI POSSIVEL A TABELA formato.\n";
  exit 1;
}

print "============ Lista de usuario cadastrados no sistema ===========\n";
my @usuarios=&EXECUTA_BANCO("select usuario.login,usuario.cod_usuario,grupo.nome_grupo,grupo.cod_grupo from usuario,grupo where usuario.cod_grupo=grupo.cod_grupo;");
if (scalar @usuarios < 1) {
  print "Nao ha usuarios cadastrados no sistema\n";
} else {
 foreach $i (0..$#usuarios){
     print "$usuarios[$i]\n";
 } 
}

print "========= Lista de impressoras cadastradas no sistema ==========\n";
my @usuarios=&EXECUTA_BANCO("select impressora.fila_virtual from impressora;");
if (scalar @usuarios < 1) {
  print "Nao ha impressoras cadastradas no sistema\n";
} else {
 foreach $i (0..$#usuarios){
     print "$usuarios[$i]   -        ";
     $spool=&SPOOL_IMPRESSORA($usuarios[$i]);
     print "$spool  -         ";
     if (-e $spool){
         print "path_spool OK\n";
     } else {
         print "ERRO path_spool INVALIDO\n";
     }
 }
}

print "============== Lista de Politicas de Impressao  =================\n";
my @usuarios=&EXECUTA_BANCO("select politica.cod_politica,politica.cod_grupo,conjunto_impressora.cod_impressora
                             from politica,conjunto_impressora
                             where conjunto_impressora.cod_politica=politica.cod_politica;");
if (scalar @usuarios < 1) {
  print "Nao ha Politicas cadastradas no sistema\n";
} else {
 foreach $i (0..$#usuarios){
     print "Cod_politica e cod_grupo e Cod_impressora $usuarios[$i]  \n";
 }
}

print "================ Lista de Tentativas Impressao  =================\n";
my @usuarios=&EXECUTA_BANCO("select impressoes.cod_politica,impressoes.cod_usuario,impressoes.paginas,impressoes.cod_status_impressao from impressoes;");
if (scalar @usuarios < 1) {
  print "Nao ha tentativas de impressoes cadastradas no sistema\n";
} else {
 foreach $i (0..$#usuarios){
     print "Cod_politica Cod_usuario Paginas Status $usuarios[$i]  \n";
 }
}

print "===================== Saida do ibquota.log  =====================\n";
if (-e "ibquota.log") {
  $saida=`cat ibquota.log`;
  print "$saida\n";
} else {
  print "Arquivo ibquota.log nao encontrado\n";
} 

print "===================== Saida do gg/error.log  =====================\n";
if (-e "gg/error.log") {
  $saida=`ls -l gg/error.log`;
  print "$saida\n";
  $saida=`cat gg/error.log`;
  print "$saida\n";
} else {
  print "Arquivo gg/error.log nao encontrado\n";
}


print "\n===================== Saida do LPSTAT -T  ========================\n";
$saida=`$configuracoes{'PATH_LPSTAT'} -t`;
print "$saida\n";
                                                                                                               
print "\n==================== Saida do /etc/printcap  =====================\n";
$saida=`more /etc/printcap`;
print "$saida\n";

print "\n==================== Saida do ps aux | grep cupsd  =====================\n";
$saida=`ps aux | grep "cupsd" | grep -v "ps aux"`;
print "$saida\n";
$saida=`ps aux | grep "lpd" | grep -v "ps aux"`;
print "$saida\n";


print "============================ PHP.INI ===================================\n";

$achou=0;
$php="/usr/local/lib/php.ini";
if (-e $php) {
  print "$php ";
  $saida=`cat $php | grep "register_globals"`;
  print "   $saida\n";
  $achou=1;
} 

$php="/etc/php.ini";
if (-e $php) {
  print "$php ";
  $saida=`cat $php | grep "register_globals"`;
  print "   $saida\n";
  $achou=1;
}


if ($achou < 1) {
  print "OBS: Nao foi possivel identificar o arquivo php.ini\n";
} 

print "========================= PRINTERS.CONF ================================\n";
$achou=0;
$php="/etc/cups/printers.conf";
if (-e $php) {
  print "$php \n";
  $saida=`cat $php`;
  print "   $saida\n";
  $achou=1;
}
                                                                                                               
$php="/usr/local/cups/etc/cups/printers.conf";
if (-e $php) {
  print "$php \n";
  $saida=`cat $php`;
  print "   $saida\n";
  $achou=1;
}
                                                                                                               
                                                                                                               
if ($achou < 1) {
  print "OBS: Nao foi possivel identificar o arquivo printers.conf\n";
}





print "\nFIM DO CHECK-UP -";
$saida=`date`;
print "$saida\n";
